<?php
include '../common.php';

// Forberedelser er en fil med funksjoner og klasser for diverse brukte metoder. De er lagt der for å lettere kunne
// bruke dem flere steder, og så er det mye ryddigere.
include 'forberedelser.php';

?><!DOCTYPE html>
<html lang="no">
<head>
    <title><?=title();?></title>
    <link rel="stylesheet" href="../index.css">
</head>
<body>

<div class="container">
    <h1><?=title();?></h1>
    <h4><?=getNavigation();?></h4>
    <h2>Medlemsliste</h2>

    <?php
    // Tom matrise som skal holde Medlem-objekter.
    $medlemmer = array();

    // Se funksjonen i forberedelser.php
    // Parametrene er sidetall, i tilfelle det er kjempemange medlemmer. (Standard 20 per side, side 1)
    $medlemmer = hentMedlemmer($_GET['size'] ?? 20, $_GET['page'] ?? 1);
    ?>
</div>

<div style="text-align: center; margin-bottom: 50px;">
    <?php
    // Koden er ganske lik den brukt i modul 4 oppgave 3.
    if(!empty($medlemmer)){
        ?>
        <table class="table">
            <thead>
            <tr>
                <th>#</th>
                <th>Fornavn</th>
                <th>Etternavn</th>
                <th>Adresse</th>
                <th>Postnummer/-sted</th>
                <th>Mobilnummer</th>
                <th>E-post</th>
                <th>Fødselsdato</th>
                <th>Kjønn</th>
<!--                <th>Interesser</th>-->
<!--                <th>Kursaktiviteter</th>-->
                <th>Medlem siden</th>
                <th>Kontigentstatus</th>
            </tr>
            </thead>
            <tbody>
            <?php
            $counter = 0;
            foreach ($medlemmer as $medlemID => $medlem){
                $counter++;
                echo "<tr>\n";
                echo "    <td>".($counter)."</td>\n";
                echo "    <td>".($medlem->fornavn ?? '')."</td>\n";
                echo "    <td>".($medlem->etternavn ?? '')."</td>\n";
                echo "    <td>".($medlem->adresse1 ?? '');
                if(!empty($medlem->adresse2)){ echo "<br>".$medlem->adresse2; } // Skriver inn adresselinje 2 hvis aktuelt
                echo "</td>\n";
                echo "    <td>{$medlem->postnummer} {$medlem->poststed}</td>\n";
                echo "    <td>".($medlem->mobilnummer ?? '')."</td>\n";
                echo "    <td>".($medlem->epost ?? '')."</td>\n";
                echo "    <td>".($medlem->dob->format('d. M Y') ?? '')."</td>\n";
                echo "    <td>".($medlem->kjoenn ?? '')."</td>\n";
//                echo "    <td>".(implode(', ', $medlem->interesser) ?? '')."</td>\n";
//                echo "    <td>".($medlem->kursaktiviteter ?? '')."</td>\n";
                echo "    <td>".($medlem->medlem_siden->format('d. M Y') ?? '')."</td>\n";
                echo "    <td>".($medlem->kontigentstatus ?? '')."</td>\n";
//                echo "    <td><form action='index6_2.php'><input type='hidden' name='memberid' value='".$medlem->dbid."'><input type='submit' value='Rediger...'></form></td>\n";
                echo "</tr>\n";
            }
            ?>
            </tbody>
        </table>
    <?php } ?>
</div>

</body>
</html>